import React, { useState } from 'react';
import ScriptLoader from '@s-ui/react-script-loader';
import { useMount } from '@s-ui/react-hooks';
var CAPTCHA_SRC = 'https://www.google.com/recaptcha/api.js?render=explicit';
var CAPTCHA_ID = 'sui-FormCaptchaContainer';
var CAPTCHA_SIZES = {
  COMPACT: 'compact',
  NORMAL: 'normal'
};
var CAPTCHA_DEFAULT_SIZE = CAPTCHA_SIZES.NORMAL;

var CAPTCHA_VERIFIER = function CAPTCHA_VERIFIER() {
  return typeof window !== 'undefined' && typeof window.grecaptcha !== 'undefined' && typeof window.grecaptcha.render !== 'undefined';
};

var FormCaptcha = function FormCaptcha(_ref) {
  var siteKey = _ref.siteKey,
      locale = _ref.locale,
      _ref$onSubmit = _ref.onSubmit,
      onSubmit = _ref$onSubmit === void 0 ? function () {} : _ref$onSubmit,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? CAPTCHA_DEFAULT_SIZE : _ref$size;

  var _useState = useState(false),
      showCaptcha = _useState[0],
      setShowCaptcha = _useState[1];

  var _useState2 = useState(null),
      captchaId = _useState2[0],
      setCaptchaId = _useState2[1];

  var reset = function reset() {
    if (captchaId !== null) {
      window.grecaptcha.reset(captchaId);
    }

    onSubmit('');
  };

  var load = function load() {
    if (captchaId !== null) return null;

    try {
      var widgetId = window.grecaptcha.render(CAPTCHA_ID, {
        sitekey: siteKey,
        hl: locale,
        callback: onSubmit,
        'expired-callback': reset,
        size: size
      });
      setCaptchaId(widgetId);
    } catch (e) {}

    return null;
  };

  useMount(function () {
    setShowCaptcha(true);
    return function () {
      reset();
    };
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, showCaptcha && /*#__PURE__*/React.createElement("div", {
    id: CAPTCHA_ID
  }, /*#__PURE__*/React.createElement(ScriptLoader, {
    isAsync: true,
    render: load,
    src: CAPTCHA_SRC,
    verifier: CAPTCHA_VERIFIER
  })));
};

FormCaptcha.displayName = 'FormCaptcha';
export { CAPTCHA_SIZES };
export default FormCaptcha;